/* ../src/inhull.f -- translated by f2c (version 19950110).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int inhull_(xp, yp, np, x, y, n, list, lptr, lend, inh)
doublereal *xp, *yp;
integer *np;
doublereal *x, *y;
integer *n, *list, *lptr, *lend;
logical *inh;
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    extern logical left_();
    static integer k, nodes[1], n0, ip, lp, nst;


/* *********************************************************** */

/*                                               From TRIPACK */
/*                                            Robert J. Renka */
/*                                  Dept. of Computer Science */
/*                                       Univ. of North Texas */
/*                                             (817) 565-2767 */
/*                                                   09/01/88 */

/*   Modified version of BNODES from TRIPACK */
/*   Albrecht Gebhardt <albrecht.gebhardt@uni-klu.ac.at> */

/* This function returns TRUE if a given point is contained */
/* in the convex hull of a given triangulation. */

/* On input: */

/*       PX,PY = coordinates of the point to be located */

/*       X,Y = Arrays containing the coordinates of the nodes */
/*             in the triangulation. */

/*       N = Number of nodes in the triangulation.  N .GE. 3. */

/*       LIST,LPTR,LEND = Data structure defining the trian- */
/*                        gulation.  Refer to subroutine */
/*                        TRMESH. */

/* The above parameters are not altered by this routine. */

/* Return value: */

/*       TRUE if (PX,PY) lies in convex hull of the triangulation. */

/*       This is determined by sequentially applying the LEFT */
/*       function along the boundary (counterclockwise). */
/*       If all these tests return TRUE (PX,PY) lies in the convex hull. 
*/

/* Modules required by INHULL:  LEFT */

/* *********************************************************** */

    /* Parameter adjustments */
    --xp;
    --yp;
    --x;
    --y;
    --lend;
    --list;
    --lptr;
    --inh;

    /* Function Body */
    i__1 = *np;
    for (ip = 1; ip <= i__1; ++ip) {

/*     initialize LOGICAL INH */

	inh[ip] = TRUE_;

/*     Set NST to the first boundary node encountered. */

	nst = 1;
L1:
	lp = lend[nst];
	if (list[lp] < 0) {
	    goto L2;
	}
	++nst;
	goto L1;

/*     Initialization. */

L2:
	nodes[0] = nst;
	k = 1;
	n0 = nst;

/*     Traverse the boundary in counterclockwise order. */

L3:
	lp = lend[n0];
	lp = lptr[lp];
	n0 = list[lp];
	if (n0 == nst) {
	    goto L4;
	}
	++k;
	nodes[k - 1] = n0;

/*    Check if point (X,Y) is left of the line through NODES(K-1)->NOD
ES(K),*/

	inh[ip] = inh[ip] && left_(&x[nodes[k - 2]], &y[nodes[k - 2]], &x[
		nodes[k - 1]], &y[nodes[k - 1]], &xp[ip], &yp[ip]);
	goto L3;

/*    Check if point (X,Y) is left of the line through NODES(NB)->NODE
S(1),*/

L4:
	inh[ip] = inh[ip] && left_(&x[nodes[k - 1]], &y[nodes[k - 1]], &x[
		nodes[0]], &y[nodes[0]], &xp[ip], &yp[ip]);
/* L10: */
    }
    return 0;
} /* inhull_ */

